Integrationtests
---
Testen Schnittstellen und Interaktion zwischen Komponenten

**Strategien**
* {{Big-Bang-Integration}}
* {{Horizontale Integration}}
  * {{Top-Down-Integration}}
  * {{Bottom-Up-Integration}}
* {{Vertikale Integration}}
---
Big Bang
---
Gesamtes System wird auf einmal getestet

Vorteil: {{Keine zusätzlichen Aufwände für Stubs oder Testtreiber}}
Nachteile: {{Fehler schwerer lokalisierbar}}, {{ Hohes Risiko bei Integration}}, {{erst spät möglich}}
Anwendung: {{Kleine, überschaubare Produkte}}


Top-Down (Horizontale Integration)
---
Höhere Anwendungsschichten werden zuerst umgesetzt, unteren werden simuliert durch stubs
Vorteile: {{Ausführbares Produkt Framework früh vorhanden}}, {{Demo-Prototypen, Framework für Testfälle}}
Nachteile: {{Hoher Aufwand für Test-Stubs}}, {{späte Integration von Hardware}}

Anwendungsbeispiel: {{ P2P Payment App über Bluetooth, zuerst wird getestet ob das Zahlen funktioniert ohne Berücksichtigung zur Bluetooth Verbindung }}

Bottom-Up (Horizontale Integration)
---
Untere Anwendungsschichten werden zuerst umgesetzt, es existieren mehrere Testtreiber um von jeder Schicht "wegstarten" zu können

Vorteile: {{Keine Stubs notwenig}}
Nachteile: {{Ausführbares Gesamtsystem erst spät verfügbar}}, {{zusätzlicher Aufwand für Prototypen & Test-Drivers}}

Anwendungsbeispiel: {{ P2P Payment App über Bluetooth, zuerst wird getestet ob die Bluetooth Verbindung funktioniert ohne Berücksichtigung des "eigentlichen Use-Cases"}}

Vertikale Integration
---
Pro Use Case werden immer die Komponenten, die dafür notwenig sind, gemeinsam getestet

Vorteile: {{Frühe Verfügbarkeit von funktionalen Anforderungen}}, {{Prototypen & Demo}}, {{Berücksichtigung priorisierter Anforderungen möglich}} 
Nachteile: {{Alle Schichten müssen jeweilige Funktionalität unterstützen}}, {{Synchronisation in der Entwicklung notwenig}}, {{Regression-Tests}}

Anwendungsbeispiel: {{ P2P Payment App über Bluetooth, es wird immer ein Feature auf einmal getestet, d.h. zuerst wird getestet kann ich einen QR-Code über Bluetooth scannen und so eine P2P verbindung aufbauen zu dem anderen Gerät?}}