Vorgangsbeziehungen
---
Sind Abhängigkeiten der Start-/Endzeitpunkte von Vorgängen untereinander
---
Es gibt 4 verschiedene Arten von Vorgangsbeziehungen:
* {{Ende-Anfangs-Beziehung (EA)}}
* {{Anfangs-Anfangs-Beziehung (AA)}}
* {{Ende-Ende-Beziehung (EE)}}
* {{Anfangs-Ende-Beziehung}}
---
EA-Beziehung
---
"Typische" Sequenzielle Abarbeitung: Ende von Vorgang 1 ist Voraussetzung für Start von Vorgang 2

Beispiel:
Vorgang 1 = Schnittstelle für Daten definieren
Vorgang 2 = Daten aus dieser Schnittstelle auslesen
-> Gegenargument: Mocking
---
AA-Beziehung
---
Komplett parallele Abarbeitung: Vorgang 1 und Vorgang 2 können unabhängig voneinader starten

Beispiel:
Vorgang 1 = Schnittstelle für Kundendaten definieren
Vorgang 2 = Schnittstelle für Unternehmendaten definieren
---
EE-Beziehung
---
Komplett parallele Abarbeitung: Vorgang 1 und Vorgang 2 können unabhängig voneinander enden

Beispiel:
Vorgang 1 = Schnittstelle für Kundendaten definieren
Vorgang 2 = Schnittstelle für Unternehmendaten definieren
---
AE-Beziehung
---
Semi-parallel bzw. semi-sequenzielle Abarbeitung: Start von Vorgang 1 ist Voraussetzung für Ende von Vorgang 2

(sehr fiktives) Beispiel:
Vorgang 1 = Testsuite ausführen
Vorgang 2 = Tests passen alle